SystemOrganization addCategory: #'Kernel-ClassBuilder'!

IRVisitor subclass: #MethodFieldUpdater
	instanceVariableNames: 'methodModification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!MethodFieldUpdater methodsFor: 'private' stamp: 'CamilloBruni 3/28/2011 18:43'!
decompile: aMethod

	^ OCBytecodeDecompiler new decompile: aMethod! !

!MethodFieldUpdater methodsFor: 'accessing' stamp: 'ToonVerwaest 3/27/2011 21:17'!
recompileMethod: method withSelector: selector to: aClass
	| ir newMethod |
	ir := self decompile: method.
	ir accept: self.
	newMethod := ir compiledMethodWith: method trailer.
	newMethod selector: selector.
	newMethod methodClass: aClass.
	aClass methodDict at: selector put: newMethod! !

!MethodFieldUpdater methodsFor: 'accessing' stamp: 'ToonVerwaest 3/27/2011 19:51'!
transformAll: methodDict using: aMethodModification to: aClass
	methodModification := aMethodModification.
	methodDict keysAndValuesDo: [ :selector :method |
		self recompileMethod: method withSelector: selector to: aClass ]! !

!MethodFieldUpdater methodsFor: 'visiting' stamp: 'ToonVerwaest 3/28/2011 17:52'!
visitInstVarAccess: anInstVarAccess
	(methodModification modificationAt: anInstVarAccess number)
		applyToIR: anInstVarAccess! !

!MethodFieldUpdater methodsFor: 'visiting' stamp: 'ToonVerwaest 3/28/2011 20:01'!
visitPushLiteral: aPushLiteral
	(aPushLiteral literal isKindOf: AbstractFieldModification)
		ifTrue: [
			aPushLiteral literal
				rewriteIR: aPushLiteral
				usingModification: methodModification ]! !

Exception subclass: #ClassModificationConflict
	instanceVariableNames: 'modification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!ClassModificationConflict methodsFor: 'exceptiondescription' stamp: 'ToonVerwaest 3/21/2011 01:12'!
defaultAction
	"No one has handled this error, but now give them a chance to decide how to debug it.  If none handle this either then open debugger (see UnhandedError-defaultAction)"

	UnhandledError signalForException: self! !

!ClassModificationConflict methodsFor: 'private' stamp: 'ToonVerwaest 3/21/2011 01:13'!
isResumable
	"Determine whether an exception is resumable."

	^ false! !

ClassModificationConflict subclass: #PrimitiveTypeConflict
	instanceVariableNames: 'layout subType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:28'!
layout
	^ layout! !

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:28'!
layout: anObject
	layout := anObject! !

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:30'!
messageText
	^ 'Class with ', layout class name, ' cannot be extended as ', subType! !

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:28'!
subType
	^ subType! !

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:28'!
subType: anObject
	subType := anObject! !

ClassModificationConflict subclass: #SlotDuplicationConflict
	instanceVariableNames: 'newSlot oldSlot host'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:15'!
host
	^ host! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:15'!
host: anObject
	host := anObject! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:17'!
messageText
	^ 'Slot #''', oldSlot name, ''' appeared twice in ', host name! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:10'!
newSlot
	^ newSlot! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:10'!
newSlot: anObject
	newSlot := anObject! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:10'!
oldSlot
	^ oldSlot! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:10'!
oldSlot: anObject
	oldSlot := anObject! !

SlotObject subclass: #Layout
	instanceVariableNames: 'host compactClassIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

Layout subclass: #BitsLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!BitsLayout methodsFor: 'extending' stamp: 'CamilloBruni 3/30/2011 15:31'!
extend: slotArray
	PrimitiveTypeConflict new
		layout: self;
		signal! !

!BitsLayout methodsFor: 'initialization' stamp: 'CamilloBruni 3/19/2011 23:45'!
initialize: instance
	"nothing to do"! !

!BitsLayout methodsFor: 'testing' stamp: 'ToonVerwaest 3/16/2011 21:27'!
isBits
	^ true! !

!BitsLayout methodsFor: 'testing' stamp: 'ToonVerwaest 3/16/2011 21:27'!
isVariable
	^ true! !

!BitsLayout methodsFor: 'printing' stamp: 'CAmi 3/17/2011 15:59'!
printSlotDefinitionOn: aStream
	"no slots available"! !

BitsLayout subclass: #ByteLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!ByteLayout classSide methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/22/2011 17:36'!
buildFrom: superLayout slots: someSlots
	someSlots isEmpty ifFalse: [ self error: 'No slots expected!!' ].
	^ superLayout extendByte! !

!ByteLayout methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 15:33'!
extendWord
	PrimitiveTypeConflict new
		layout: self;
		subType: #word;
		signal! !

!ByteLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 3/16/2011 21:01'!
instanceSpecification
	^ 8! !

!ByteLayout methodsFor: 'reshape' stamp: 'ToonVerwaest 3/20/2011 15:09'!
reshapeTo: aModification
	^ aModification layout extendByte! !

BitsLayout subclass: #WordLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!WordLayout classSide methodsFor: 'instance creation' stamp: 'CamilloBruni 3/22/2011 18:43'!
buildFrom: superLayout slots: someSlots
	someSlots isEmpty 
		ifFalse: [ self error: 'No slots expected!!' ].
	^ superLayout extendWord! !

!WordLayout methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 15:32'!
extendByte
	PrimitiveTypeConflict new
		layout: self;
		subType: #byte;
		signal! !

!WordLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 3/16/2011 21:01'!
instanceSpecification
	^ 6! !

!WordLayout methodsFor: 'reshape' stamp: 'ToonVerwaest 3/20/2011 15:09'!
reshapeTo: aModification
	^ aModification layout extendWord! !

!Layout classSide methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/22/2011 17:39'!
buildFrom: superLayout slots: slots
	self subclassResponsibility! !

!Layout methodsFor: 'comparing' stamp: 'CamilloBruni 3/31/2011 15:04'!
= anObject
	(anObject isKindOf: self class)
		ifFalse: [ ^ false].
	^ true! !

!Layout methodsFor: 'testing' stamp: 'ToonVerwaest 3/17/2011 17:14'!
addedSlots
	^ false! !

!Layout methodsFor: 'testing' stamp: 'CamilloBruni 3/30/2011 18:41'!
checkSanity
	self assert: self host isNil not.! !

!Layout methodsFor: 'accessing' stamp: 'ToonVerwaest 3/23/2011 23:29'!
compactClassIndex: anIndex
	compactClassIndex := anIndex.
	self host setFormat: self format! !

!Layout methodsFor: 'diff' stamp: 'ToonVerwaest 3/20/2011 15:47'!
computeChangesFrom: other in: modification
	other hasSlots 
		ifTrue: [ ^ modification removals: (Array newFrom: other) ].! !

!Layout methodsFor: 'extending' stamp: 'ToonVerwaest 3/21/2011 01:27'!
extend: slotArray
	PrimitiveTypeConflict new
		layout: self;
		subType: #slot;
		signal! !

!Layout methodsFor: 'extending' stamp: 'CamilloBruni 3/30/2011 19:21'!
extend: slotArray layout: layoutClass
	
	^ SlotLayoutBuilder make: [:builder| 
		builder layout: layoutClass.
		builder addSlots: self.
		builder addSlots: slotArray.
	].
	! !

!Layout methodsFor: 'extending' stamp: 'CamilloBruni 3/30/2011 15:16'!
extendByte
	^ ByteLayout new! !

!Layout methodsFor: 'extending' stamp: 'ToonVerwaest 3/21/2011 01:27'!
extendVariable: slotArray
	PrimitiveTypeConflict new
		layout: self;
		subType: #variable;
		signal! !

!Layout methodsFor: 'extending' stamp: 'ToonVerwaest 3/19/2011 17:34'!
extendWeak
	^ WeakLayout new! !

!Layout methodsFor: 'extending' stamp: 'ToonVerwaest 3/19/2011 17:34'!
extendWord
	^ WordLayout new! !

!Layout methodsFor: 'initialization' stamp: 'ToonVerwaest 3/23/2011 23:50'!
fetchCompactIndex
	compactClassIndex := host indexIfCompact! !

!Layout methodsFor: 'initialization' stamp: 'CamilloBruni 3/20/2011 17:13'!
finalize
	"self subclassResponsibility"! !

!Layout methodsFor: 'initialization' stamp: 'CamilloBruni 3/22/2011 18:37'!
finalizeWithClass: aClass
	self host: aClass.
	self finalize.! !

!Layout methodsFor: 'searching' stamp: 'CamilloBruni 3/28/2011 16:47'!
findSuperLayout: searchBlock ifAbsent: absentBlock
	| currentLayout |
	currentLayout := self.
	[searchBlock value: currentLayout] whileFalse: [
		currentLayout host superclass ifNil: absentBlock.
		currentLayout := currentLayout host superclass layout].
	^ currentLayout! !

!Layout methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 14:21'!
fixedSize
	^ 0! !

!Layout methodsFor: 'accessing' stamp: 'ToonVerwaest 3/23/2011 23:14'!
format
	| fixedSize sizeHiBits instanceSpecification format |
	fixedSize := self fixedSize + 1.
	sizeHiBits := fixedSize // 64.
	instanceSpecification := self instanceSpecification.
	format := sizeHiBits.
	format := (format bitShift: 5) + compactClassIndex.
	format := (format bitShift: 4) + instanceSpecification.
	format := (format bitShift: 6) + (fixedSize \\ 64).
	format := (format bitShift: 1).
	^ format! !

!Layout methodsFor: 'converting' stamp: 'CamilloBruni 3/29/2011 15:58'!
freeze
	self flag: 'to be implemented'.
	^ self! !

!Layout methodsFor: 'testing' stamp: 'ToonVerwaest 3/17/2011 13:46'!
hasSlots
	^ false! !

!Layout methodsFor: 'accessing' stamp: 'CAmi 3/15/2011 18:57'!
host
	^ host! !

!Layout methodsFor: 'accessing' stamp: 'CAmi 3/15/2011 18:57'!
host: aClass
	host := aClass! !

!Layout methodsFor: 'initialization' stamp: 'ToonVerwaest 3/23/2011 23:14'!
initialize
	compactClassIndex := 0! !

!Layout methodsFor: 'initialization' stamp: 'CamilloBruni 3/19/2011 23:45'!
initialize: instance
	self subclassResponsibility! !

!Layout methodsFor: 'accessing' stamp: 'ToonVerwaest 3/16/2011 21:00'!
instanceSpecification
	self subclassResponsibility! !

!Layout methodsFor: 'testing' stamp: 'ToonVerwaest 3/16/2011 21:27'!
isBits
	^ false! !

!Layout methodsFor: 'testing' stamp: 'ToonVerwaest 3/16/2011 21:27'!
isVariable
	^ false! !

!Layout methodsFor: 'testing' stamp: 'ToonVerwaest 3/16/2011 21:27'!
isWeak
	^ false! !

!Layout methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 14:15'!
offset
	^ 0! !

!Layout methodsFor: 'printing' stamp: 'CamilloBruni 3/22/2011 15:45'!
printDefinitionOn: aStream
	aStream << host superclass name << ' subclass: '.
	host name storeOn: aStream.
	aStream lf << 'slots: '.
	self printSlotDefinitionOn: aStream.
	aStream lf << 'classVariableNames: '.
	aStream lf << 'poolDictionaries: '.
	aStream lf << 'category: '.
	host category storeOn: aStream.! !

!Layout methodsFor: 'printing' stamp: 'CAmi 3/17/2011 15:58'!
printSlotDefinitionOn: aStream
	self subclassResponsibility.! !

!Layout methodsFor: 'testing' stamp: 'ToonVerwaest 3/17/2011 17:14'!
removedOrModifiedSlots: previous
	^ previous hasSlots and: [ previous size > 0 ]! !

!Layout methodsFor: 'reshape' stamp: 'ToonVerwaest 3/20/2011 13:54'!
reshapeTo: aLayout
	self subclassResponsibility! !

!Layout methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:04'!
slotSize
	^ 0! !

Layout subclass: #LayoutWithSlots
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!LayoutWithSlots classSide methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 15:29'!
from: aLayout
	|instance|
	instance := self new: aLayout size.
	aLayout withIndexDo: [ :slot :index |
		instance at: index put: slot].
	^ instance! !

!LayoutWithSlots classSide methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 15:27'!
new: size
	"Overwrite Arrays default sized initalization since it does not properly initialize objects"
	^ (super new: size)
		initialize;
		yourself! !

!LayoutWithSlots methodsFor: 'comparing' stamp: 'CamilloBruni 3/31/2011 15:04'!
= other
	super = other
		ifFalse: [^ false].
	
	self size = other size
		ifFalse: [ ^ false].
		
	1 to: self size do: [ :index|
		((self at: index) = (other at: index))
			ifFalse: [ ^ false]].
		
	^ true.! !

!LayoutWithSlots methodsFor: 'testing' stamp: 'ToonVerwaest 3/17/2011 17:15'!
addedSlots: previous
	^ previous size < self size! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'CamilloBruni 3/21/2011 22:32'!
at: index put: aSlot
	aSlot ensureIndex: (self fixedSizeUpToIndex: index) + 1.
	^ super at: index put: aSlot.! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'CamilloBruni 3/25/2011 14:38'!
atIndex: instVarIndex
	"maybe use bin search here"
	| slot |
	instVarIndex to: self size do: [ :internalIndex|
		slot := (self at: internalIndex).
		(slot index == instVarIndex and: [slot needsField])
			ifTrue: [ ^ slot ]].
	^ nil! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'CamilloBruni 3/19/2011 23:43'!
atName: aSymbol
	^ self atName: aSymbol ifAbsent: [
		SlotNotFound signalForName: aSymbol].! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'CamilloBruni 3/19/2011 23:43'!
atName: aSymbol ifAbsent: aBlock
	self do: [:slot|
		slot name = aSymbol
			ifTrue: [ ^ slot ]].
	^ aBlock value.! !

!LayoutWithSlots methodsFor: 'testing' stamp: 'CamilloBruni 3/30/2011 18:41'!
checkSanity
	super checkSanity.
	self checkSlotNames.
	self checkSlotIndices! !

!LayoutWithSlots methodsFor: 'testing' stamp: 'CamilloBruni 3/30/2011 20:28'!
checkSlotIndices
	self withIndexDo: [:slot :index|
		self assert: (slot index = ((self fixedSizeUpToIndex: index) + 1))]! !

!LayoutWithSlots methodsFor: 'testing' stamp: 'CamilloBruni 3/29/2011 19:54'!
checkSlotNames
	| slots current |
	slots := OrderedCollection newFrom: self.
	[ slots isEmpty ] whileFalse: [
		current := slots removeLast.
		slots do: [ :other |
			other name == current name
				ifTrue: [ 
					SlotDuplicationConflict new
							oldSlot: current;
							newSlot: other;
							host: host;
							signal ]]]! !

!LayoutWithSlots methodsFor: 'diff' stamp: 'ToonVerwaest 3/28/2011 17:45'!
computeChangesFrom: other in: modification
	| additions changes removals copies |
	other hasSlots ifFalse: [ ^ modification additions: (Array newFrom: self) ].
	
	additions := OrderedCollection newFrom: self.
	removals := OrderedCollection new.
	copies := modification copies.
	changes := modification changes.
	
	other do: [ :oldSlot | 
		(self popSlot: oldSlot from: additions)
			ifNil: [ removals add: oldSlot ]
			ifNotNil: [ :newSlot |
				newSlot = oldSlot
					ifTrue: [ copies at: newSlot put: oldSlot ]
					ifFalse: [ changes at: newSlot put: oldSlot ]]].
			
	modification
		additions: additions asArray;
		removals: removals asArray.! !

!LayoutWithSlots methodsFor: 'copying' stamp: 'ToonVerwaest 3/17/2011 13:57'!
copyFrom: start to: stop 
	"Answer a copy of a subset of the receiver, starting from element at 
	index start until element at index stop."
	| newSize |
	newSize := stop - start + 1.
	^(self species new: newSize)
		replaceFrom: 1
		to: newSize
		with: self
		startingAt: start! !

!LayoutWithSlots methodsFor: 'enumerating' stamp: 'ToonVerwaest 3/17/2011 13:51'!
do: aBlock 
	"Refer to the comment in Collection|do:."
	1 to: self size do:
		[:index | aBlock value: (self at: index)]! !

!LayoutWithSlots methodsFor: 'extending' stamp: 'CamilloBruni 3/30/2011 19:21'!
extend: slotArray
	^ self extend: slotArray layout: PointerLayout! !

!LayoutWithSlots methodsFor: 'extending' stamp: 'CamilloBruni 3/30/2011 15:29'!
extendVariable: slotArray
	^ self extend: slotArray layout: VariableLayout
"	| mySize layout |
	mySize := self size.
	
	create the new layout and copy in the super slots
	layout := VariableLayout new: slotArray size + mySize.
	layout replaceFrom: 1 to: mySize with: self.
	
	create new slots
	slotArray withIndexDo: [ :slot :index|
		layout at: mySize + index put: slot asSlot].
	layout finalize.
	^ layout"! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'CamilloBruni 3/20/2011 16:03'!
fixedSize
	|size|
	size := 0.
	self do: [ :slot|
		size := size + slot size].
	^ size! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'CamilloBruni 3/29/2011 15:55'!
fixedSizeUpToIndex: index
	|size|
	size := 0.
	1 to: index -1 do: [ :i| 
		size := size + (self at: i) size].
	^ size! !

!LayoutWithSlots methodsFor: 'testing' stamp: 'ToonVerwaest 3/17/2011 13:50'!
hasSlots
	^ true! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'CamilloBruni 3/19/2011 23:43'!
includesName: aSymbol
	self atName: aSymbol ifAbsent: [ ^ false].
	^ true! !

!LayoutWithSlots methodsFor: 'initialization' stamp: 'ToonVerwaest 3/20/2011 22:35'!
initialize: instance
	self do: [ :slot |
		slot initialize: instance]! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'CamilloBruni 3/19/2011 23:47'!
instanceSpecification
	| base |
	base := self instanceSpecificationBase.
	self size > 0 
		ifTrue: [ ^ base + 1 ].
	^ base! !

!LayoutWithSlots methodsFor: 'private accessing' stamp: 'ToonVerwaest 3/17/2011 13:52'!
instanceSpecificationBase
	self subclassResponsibility! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'CamilloBruni 3/22/2011 19:41'!
instanceVariablesFrom: offset
	| result slot |
	offset > self slotSize
		ifTrue: [ self error: 'Offset out of bounds' ].
	result := OrderedCollection new.
	1 to: (self slotSize - offset) do: [ :idx | 
		slot := (self at: offset + idx).
		slot size = 0
			ifFalse: [ result add: slot name ] ].
	^ result! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 22:42'!
offset
	host ifNil: [ self error: 'Layout is not properly installed' ].
	^ 0 + (host superclass 
				ifNil: [ 0 ] 
				ifNotNil: [host superclass layout size ]).! !

!LayoutWithSlots methodsFor: 'diff' stamp: 'ToonVerwaest 3/19/2011 19:51'!
popSlot: aSlot from: collection
	collection withIndexDo: [ :slot :index |
		slot name == aSlot name
			ifTrue: [ ^ collection removeAt: index ]].
	^ nil! !

!LayoutWithSlots methodsFor: 'printing' stamp: 'CamilloBruni 3/28/2011 17:14'!
printSlotDefinitionOn: aStream
	| slot printedAtLeastOnSlot|
	
	self size = 0 
		ifTrue: [ ^ aStream << '{}'].
		
	printedAtLeastOnSlot := false.
	aStream << '{'.
	
	self offset + 1 to: self size do: [ :index| 
		slot := (self at: index).
		slot isVisible
			ifTrue: [
				aStream lf; tab; tab; store: slot; << '.'.
				printedAtLeastOnSlot := true.]].
			
	printedAtLeastOnSlot ifTrue: [ aStream lf; tab ].
	aStream << '}'.! !

!LayoutWithSlots methodsFor: 'testing' stamp: 'CamilloBruni 3/19/2011 23:48'!
removedOrModifiedSlots: previous
	previous hasSlots 
		ifFalse: [ ^ false ].
	previous size > self size 
		ifTrue: [ ^ true ].
	previous withIndexDo: [ :slot :index | 
		(self at: index) = slot ifFalse:  [ ^ true ]].
	^ false! !

!LayoutWithSlots methodsFor: 'enumerating' stamp: 'ToonVerwaest 3/17/2011 13:51'!
replaceFrom: start to: stop with: replacement 
	"This destructively replaces elements from start to stop in the receiver. 
	Answer the receiver itself. Use copyReplaceFrom:to:with: for 
	insertion/deletion which may alter the size of the result."

	replacement size = (stop - start + 1)
		ifFalse: [self error: 'Size of replacement doesnt match'].
	^self replaceFrom: start to: stop with: replacement startingAt: 1! !

!LayoutWithSlots methodsFor: 'enumerating' stamp: 'ToonVerwaest 3/17/2011 13:51'!
replaceFrom: start to: stop with: replacement startingAt: repStart 
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."
	<primitive: 105>
	super replaceFrom: start to: stop with: replacement startingAt: repStart! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:04'!
slotSize
	^ self size! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 15:13'!
slotsFrom: anOffset
	^ self copyFrom: anOffset to: self size! !

!LayoutWithSlots methodsFor: 'enumerating' stamp: 'CamilloBruni 3/19/2011 23:48'!
withIndexDo: elementAndIndexBlock 
	"Just like with:do: except that the iteration index supplies the second argument to the block."
	1 to: self size do: [:index |
		elementAndIndexBlock
			value: (self at: index)
			value: index]! !

LayoutWithSlots variableSubclass: #PointerLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!PointerLayout classSide methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/22/2011 14:20'!
buildFrom: superLayout slots: slots
	^ superLayout extend: slots! !

!PointerLayout methodsFor: 'extending' stamp: 'ToonVerwaest 3/21/2011 01:27'!
extendByte
	self size = 0
		ifTrue: [ ^ super extendByte ].
	PrimitiveTypeConflict new
		layout: self;
		subType: #byte;
		signal! !

!PointerLayout methodsFor: 'extending' stamp: 'ToonVerwaest 3/21/2011 01:26'!
extendWord
	self size = 0 
		ifTrue: [ ^ super extendWord ].
	PrimitiveTypeConflict new
		layout: self;
		subType: #word;
		signal! !

!PointerLayout methodsFor: 'private accessing' stamp: 'ToonVerwaest 3/17/2011 13:51'!
instanceSpecificationBase
	^ 0! !

!PointerLayout methodsFor: 'reshape' stamp: 'CamilloBruni 3/30/2011 20:16'!
reshapeTo: aModification
	|offset|
	offset := aModification subclassSlotOffset.
	(offset = (self size + 1))
		ifTrue: [^ aModification layout extend: Array new].
	^ aModification layout extend: (self slotsFrom: offset)! !

LayoutWithSlots variableSubclass: #VariableLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!VariableLayout classSide methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/22/2011 14:24'!
buildFrom: superLayout slots: slots
	^ superLayout extendVariable: slots! !

!VariableLayout methodsFor: 'extending' stamp: 'CamilloBruni 3/30/2011 15:14'!
extendByte
	PrimitiveTypeConflict new
		layout: self;
		subType: #byte;
		signal! !

!VariableLayout methodsFor: 'extending' stamp: 'CamilloBruni 3/30/2011 15:15'!
extendWeak
	self size = 0 
		ifTrue: [ ^ super extendWeak ].
	PrimitiveTypeConflict new
		layout: self;
		subType: #weak;
		signal! !

!VariableLayout methodsFor: 'extending' stamp: 'CamilloBruni 3/30/2011 15:12'!
extendWord
	PrimitiveTypeConflict new
		layout: self;
		subType: #word;
		signal! !

!VariableLayout methodsFor: 'private accessing' stamp: 'ToonVerwaest 3/17/2011 13:53'!
instanceSpecificationBase
	^ 2! !

!VariableLayout methodsFor: 'testing' stamp: 'CamilloBruni 3/30/2011 19:22'!
isVariable
	^ true! !

!VariableLayout methodsFor: 'reshape' stamp: 'CamilloBruni 3/30/2011 20:16'!
reshapeTo: aModification
	|offset|
	offset := aModification subclassSlotOffset.
	(offset = (self size + 1))
		ifTrue: [^ aModification layout extendVariable: Array new].
	^ aModification layout extendVariable: (self slotsFrom: offset)! !

LayoutWithSlots variableSubclass: #WeakLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!WeakLayout classSide methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/22/2011 17:39'!
buildFrom: superLayout slots: someSlots
	someSlots isEmpty ifFalse: [ self error: 'No slots expected!!' ].
	^ superLayout extendWeak! !

!WeakLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 3/23/2011 23:29'!
compactClassIndex: anIndex
	self error: 'Don''t make weak classes compact!!'! !

!WeakLayout methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 15:15'!
extendByte
	PrimitiveTypeConflict new
		layout: self;
		subType: #byte;
		signal! !

!WeakLayout methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 15:14'!
extendWord
	PrimitiveTypeConflict new
		layout: self;
		subType: #word;
		signal! !

!WeakLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 3/16/2011 21:02'!
instanceSpecification
	^ 4! !

!WeakLayout methodsFor: 'testing' stamp: 'CamilloBruni 3/30/2011 15:13'!
isVariable
	^ false! !

!WeakLayout methodsFor: 'testing' stamp: 'ToonVerwaest 3/16/2011 21:28'!
isWeak
	^ true! !

!WeakLayout methodsFor: 'reshape' stamp: 'ToonVerwaest 3/20/2011 13:55'!
reshapeTo: aLayout
	^ aLayout extendWeak! !

Layout subclass: #SmallIntegerLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!SmallIntegerLayout classSide methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 18:45'!
format
	^ 2! !

!SmallIntegerLayout classSide methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 18:45'!
printSlotDefinitionOn: aStream
	aStream << '{}'! !

!SmallIntegerLayout methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 19:21'!
extend: slotArray
	^ self extend: slotArray layout: PointerLayout! !

!SmallIntegerLayout methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 19:20'!
format
	^ 2! !

!SmallIntegerLayout methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 19:21'!
printSlotDefinitionOn: aStream
	aStream << '{}'! !

SlotObject subclass: #Slot
	instanceVariableNames: 'index name uninitializedValue modifiers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!Slot class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/22/2011 16:40'!
asSlot
	^ self new! !

!Slot class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/10/2011 16:35'!
named: aSymbol
	^ self new
		name: aSymbol;
		yourself! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 18:47'!
= other
	self == other
		ifTrue: [ ^ true ].
	^ ((self species == other species) 
			and: [ index = other index ])
			and: [ name = other name]! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 14:34'!
asSlot
	^ self! !

!Slot methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 3/17/2011 14:03'!
ensureIndex: anIndex
	index := anIndex! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 16:55'!
finalize: layout
	"nothing to do here"! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/10/2011 15:01'!
index
	^ index! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/10/2011 17:17'!
initialize: instance
	"nothing to do for the default slot"! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CAmi 3/14/2011 19:42'!
inline
	^ self class == Slot! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:48'!
internalRead: anObject
	^ anObject instVarAt: index! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:48'!
internalWrite: aValue to: anObject
	anObject instVarAt: index put: aValue.! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:38'!
invalidReadAccess
	ReadAccessError signal! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:38'!
invalidReadAccess: aMessage
	ReadAccessError signal: aMessage! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:38'!
invalidWriteAccess
	WriteAccessError signal! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/24/2011 18:38'!
invalidWriteAccess: aMessage
	WriteAccessError signal: aMessage! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 18:46'!
isVisible
	^ true! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/10/2011 15:01'!
name
	^ name! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:16'!
name: aSymbol
	aSymbol ensureType: Symbol.
	name := aSymbol! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 14:38'!
needsField
	^ true! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 15:37'!
printOn: aStream
	aStream << self name << ' => '; << self class name.! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 18:46'!
read: anObject
	^ self internalRead: anObject! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 14:32'!
size
	^ 1! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 17:59'!
storeInitializationOn: aStream
	aStream nextPutAll: self class name! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2011 16:36'!
storeOn: aStream
	aStream store: self name.
	aStream nextPutAll: ' => '.
	self storeInitializationOn: aStream.! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 18:46'!
variableNodeForClass: aClass
	| instVarname |
	instVarname := aClass instVarNameForIndex: index.
	^ RBVariableNode named: instVarname! !

!Slot methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 18:46'!
write: aValue to: anObject
	self internalWrite: aValue to: anObject! !

Object subclass: #AbstractClassBuilderClient
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!AbstractClassBuilderClient classSide methodsFor: 'building' stamp: 'ToonVerwaest 3/22/2011 19:12'!
make: aBlock
	| builder |
	builder := self new builder.
	aBlock value: builder.
	^ builder build! !

!AbstractClassBuilderClient methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:42'!
builder
	^ builder! !

!AbstractClassBuilderClient methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 17:43'!
classAdded: aClass inCategory: aCategory
	self subclassResponsibility! !

!AbstractClassBuilderClient methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:44'!
classAt: aName ifAbsent: aBlock
	self subclassResponsibility! !

!AbstractClassBuilderClient methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 18:38'!
classDefinitionDeeplyChangedFrom: oldClass to: newClass by: classModification
	self subclassResponsibility! !

!AbstractClassBuilderClient methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 18:38'!
classDefinitionShallowChangedFrom: oldClass to: newClass by: classModification
	self subclassResponsibility! !

!AbstractClassBuilderClient methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:45'!
environment: anEnvironment
	self subclassResponsibility! !

!AbstractClassBuilderClient methodsFor: 'initialize-release' stamp: 'ToonVerwaest 3/22/2011 17:43'!
initialize
	builder := SlotClassBuilder new.
	builder client: self! !

!AbstractClassBuilderClient methodsFor: 'migrating' stamp: 'ToonVerwaest 3/22/2011 18:30'!
migrateClasses: old to: new using: anInstanceModification
	self subclassResponsibility! !

!AbstractClassBuilderClient methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 17:44'!
recategorize: aClass to: aCategory
	self subclassResponsibility! !

!AbstractClassBuilderClient methodsFor: 'notifications' stamp: 'CamilloBruni 3/29/2011 11:23'!
superclassChangedOf: aClass to: newClass by: classModification
	self subclassResponsibility.! !

AbstractClassBuilderClient subclass: #AnonymousClassBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!AnonymousClassBuilder methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 17:45'!
classAdded: aClass inCategory: aCategory! !

!AnonymousClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:46'!
classAt: aName ifAbsent: aBlock
	^ aBlock value! !

!AnonymousClassBuilder methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 18:38'!
classDefinitionDeeplyChangedFrom: oldClass to: newClass by: classModification! !

!AnonymousClassBuilder methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 18:38'!
classDefinitionShallowChangedFrom: oldClass to: newClass by: classModification! !

!AnonymousClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:46'!
environment: anEnvironment! !

!AnonymousClassBuilder methodsFor: 'migrating' stamp: 'ToonVerwaest 3/22/2011 18:30'!
migrateClasses: old to: new using: anInstanceModification! !

!AnonymousClassBuilder methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 17:46'!
recategorize: aClass to: aCategory! !

!AnonymousClassBuilder methodsFor: 'notifications' stamp: 'CamilloBruni 3/29/2011 11:23'!
superclassChangedOf: aClass to: newClass by: classModification! !

AbstractClassBuilderClient subclass: #PharoClassInstaller
	instanceVariableNames: 'environment instanceModification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!PharoClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 17:09'!
classAdded: aClass inCategory: aCategory
	" Install the new class in the system "
	environment at: aClass name put: aClass.
	environment flushClassNameCache.
	" Update the system's organization "
	environment organization classify: aClass name under: aCategory.
	self systemChangeNotifier classAdded: aClass inCategory: aCategory.
	" Inform superclass of new subclass "
	aClass superclass addSubclass: aClass.! !

!PharoClassInstaller methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:03'!
classAt: aName ifAbsent: aBlock
	^ (environment at: aName ifAbsent: aBlock)
		ifNil: aBlock! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/31/2011 14:20'!
classDefinitionChangedFrom: oldClass to: newClass by: classModification
	self copyMethodsFrom: oldClass to: newClass using: classModification.
	" Copy over the trait composition "
	self copyTraitCompositionFrom: oldClass to: oldClass.
	" Update the superclass links "
	oldClass superclass == newClass superclass ifFalse: [ 
		oldClass superclass removeSubclass: oldClass.
		newClass superclass addSubclass: newClass ].
	self systemChangeNotifier classDefinitionChangedFrom: oldClass to: newClass! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'CamilloBruni 3/30/2011 13:20'!
classFormatChangedFrom: oldClass to: newClass by: classModification
	self systemChangeNotifier classDefinitionChangedFrom: oldClass to: newClass! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'ToonVerwaest 3/28/2011 16:20'!
copyMethodsFrom: oldClass to: newClass using: classModification
	MethodFieldUpdater new 
		transformAll: oldClass methodDict 
		using: classModification methodModification
		to: newClass ! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'ToonVerwaest 3/22/2011 18:26'!
copyTraitCompositionFrom: old to: new
	old hasTraitComposition
		ifTrue: [ new setTraitComposition: old traitComposition copyTraitExpression ].
		! !

!PharoClassInstaller methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 16:55'!
environment: anEnvironment
	environment := anEnvironment! !

!PharoClassInstaller methodsFor: 'initialize-release' stamp: 'ToonVerwaest 3/22/2011 17:43'!
initialize
	super initialize.
	environment := nil environment.! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'ToonVerwaest 3/30/2011 13:34'!
migrateClasses: old to: new using: anInstanceModification
	instanceModification := anInstanceModification.
	old size > 0 
		ifTrue: [ [
			1 to: old size do: [ :index |
				self updateClass: (old at: index) to: (new at: index)].
			old elementsForwardIdentityTo: new.
			" Garbage collect away the zombie instances left behind in garbage memory in #updateInstancesFrom: "
			" If we don't clean up this garbage, a second update would revive them with a wrong layout!! "
			" (newClass rather than oldClass, since they are now both newClass) "
			Smalltalk garbageCollect.
		] valueUnpreemptively ]! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 16:59'!
recategorize: aClass to: aCategory
	aClass category ~~ aCategory ifTrue: [
		environment organization classify: aClass name under: aCategory.
		self systemChangeNotifier class: aClass recategorizedFrom: aClass category to: aCategory ]! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'ToonVerwaest 3/22/2011 18:54'!
shallowCopyMethodsFrom: oldClass to: newClass using: classModification
	newClass methodDict: oldClass methodDict! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/31/2011 14:19'!
superclassChangedOf: aClass to: newClass by: classModification
	|oldClass|
	oldClass := aClass copy.
	aClass superclass removeSubclass: aClass.
	aClass superclass: newClass.
	newClass addSubclass: aClass.
	self systemChangeNotifier classDefinitionChangedFrom: oldClass to: aClass.! !

!PharoClassInstaller methodsFor: 'private' stamp: 'ToonVerwaest 3/22/2011 16:57'!
systemChangeNotifier
	^ SystemChangeNotifier uniqueInstance! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'ToonVerwaest 3/23/2011 23:57'!
updateClass: oldClass to: newClass
	| compactClassIndex |
	compactClassIndex := oldClass indexIfCompact.
	compactClassIndex > 0
		ifTrue: [ newClass layout compactClassIndex: compactClassIndex ].
	self updateInstancesFrom: oldClass to: newClass! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'CamilloBruni 3/29/2011 19:32'!
updateInstancesFrom: old to: new
	| oldInstances variable instSize newInstances |
	oldInstances := old allInstances asArray.
	variable := new isVariable.
	instSize := new instSize.
	newInstances := Array new: oldInstances size.
	1 to: oldInstances size do:[:i|
		newInstances at: i put: (
			new newInstanceFrom: (oldInstances at: i) 
				 variable: variable 
				 size: instSize 
				 map: instanceModification)].
	oldInstances elementsForwardIdentityTo: newInstances.! !

Object subclass: #AbstractClassModification
	instanceVariableNames: 'target layout ownSlotStart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!AbstractClassModification methodsFor: 'public' stamp: 'ToonVerwaest 3/20/2011 23:00'!
apply
	^ target shallowCopy
		superclass: self superclass
		layout: layout
		slotStart: ownSlotStart! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'CamilloBruni 3/30/2011 19:27'!
checkSanity
	layout checkSanity.! !

!AbstractClassModification methodsFor: 'private' stamp: 'ToonVerwaest 3/21/2011 01:20'!
computeChange
	self checkSanity.! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 13:50'!
layout
	^ layout! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'CamilloBruni 3/30/2011 20:25'!
layout: aLayout
	layout := aLayout.
	layout host: target.
	self computeChange! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 19:40'!
target
	^ target! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/19/2011 15:57'!
target: aTarget
	target := aTarget! !

AbstractClassModification subclass: #ClassModification
	instanceVariableNames: 'superclass additions removals changes propagations subclassSlotOffset slotShift methodModification copies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!ClassModification classSide methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/22/2011 14:28'!
modify: aClass extend: aSuperclass withLayoutType: layoutClass slots: someSlots
	^ ClassModification new
		target: aClass;
		superclass: aSuperclass;
		layoutType: layoutClass	slots: someSlots! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 14:30'!
additions: aCollection
	additions := aCollection! !

!ClassModification methodsFor: 'migrating' stamp: 'CamilloBruni 3/29/2011 19:00'!
buildModificationMapFor: aModification
	aModification slotShift: (ShiftedField new shift: slotShift).
	
	aModification size = 0 
		ifTrue: [ ^ aModification ].
	
	additions do: [ :slot | 
		self installSlotAddition: slot on: aModification].
	
	changes keysAndValuesDo: [ :newSlot :oldSlot | 
		self installSlotChangeFrom: oldSlot to: newSlot on: aModification ].
	
	removals do: [ :slot | 
		self installSlotRemoval: slot on: aModification].
	
	copies keysAndValuesDo: [ :newSlot :oldSlot | 
		self installSlotCopiedFrom: oldSlot to: newSlot on: aModification ].
	
	^ aModification! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 15:49'!
changes
	^ changes! !

!ClassModification methodsFor: 'private' stamp: 'CamilloBruni 3/29/2011 00:24'!
computeChange
	super computeChange.
	layout computeChangesFrom: target layout in: self.
	subclassSlotOffset := target layout slotSize + 1.
	ownSlotStart := target layout offset.
	slotShift := layout fixedSize - target layout fixedSize.
	(self modifiesSlots or: [ self modifesFormat ]) 
		ifTrue: [ self propagate ].! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:45'!
copies
	^ copies! !

!ClassModification methodsFor: 'testing' stamp: 'ToonVerwaest 3/21/2011 02:00'!
formatChange
	^ (layout format = target layout format) not! !

!ClassModification methodsFor: 'initialize-release' stamp: 'ToonVerwaest 3/28/2011 17:46'!
initialize
	changes := IdentityDictionary new.
	copies := IdentityDictionary new.
	removals := {}.
	additions := {}.
	propagations := OrderedCollection new.! !

!ClassModification methodsFor: 'migrating' stamp: 'ToonVerwaest 3/28/2011 20:02'!
installSlotAddition: slot on: aModification
	0 to: slot size - 1 do: [ :idx |
		(AddedField new
			newSlot: slot;
			fieldIndex: idx) installOn: aModification  ]! !

!ClassModification methodsFor: 'migrating' stamp: 'ToonVerwaest 3/28/2011 20:02'!
installSlotChangeFrom: oldSlot to: newSlot on: aModification
	0 to: newSlot size - 1 do: [ :idx |
 		(ModifiedField new
			newSlot: newSlot;
			originalSlot: oldSlot;
			fieldIndex: idx) installOn: aModification ]! !

!ClassModification methodsFor: 'migrating' stamp: 'ToonVerwaest 3/30/2011 13:41'!
installSlotCopiedFrom: oldSlot to: newSlot on: aModification
	0 to: newSlot size - 1 do: [ :idx |
 		(UnmodifiedField new
			slot: newSlot;
			fieldIndex: idx) installOn: aModification ]! !

!ClassModification methodsFor: 'migrating' stamp: 'ToonVerwaest 3/28/2011 20:02'!
installSlotRemoval: slot on: aModification
	0 to: slot size - 1 do: [ :idx |
		(RemovedField new
			originalSlot: slot;
			fieldIndex: idx) installOn: aModification ]! !

!ClassModification methodsFor: 'migrating' stamp: 'ToonVerwaest 3/30/2011 13:47'!
instanceModification
	| map |
	map := InstanceModification new: layout fixedSize.
	^ self buildModificationMapFor: map! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 14:34'!
layoutType: layoutType slots: slots
	self layout: (layoutType buildFrom: self superLayout slots: slots)! !

!ClassModification methodsFor: 'migrating' stamp: 'CamilloBruni 3/29/2011 18:51'!
methodModification
	^ methodModification ifNil: [
		methodModification := MethodModification new: target layout fixedSize.
		self buildModificationMapFor: methodModification ]! !

!ClassModification methodsFor: 'testing' stamp: 'CamilloBruni 3/24/2011 23:53'!
modifesFormat
	^ (layout format = target layout format) not! !

!ClassModification methodsFor: 'testing' stamp: 'ToonVerwaest 3/30/2011 15:31'!
modifiesSlots
	^ (changes isEmpty and: [ removals isEmpty and: [ additions isEmpty ]]) not! !

!ClassModification methodsFor: 'testing' stamp: 'CamilloBruni 3/24/2011 23:56'!
modifiesSuperclass
	^ (target superclass == superclass) not! !

!ClassModification methodsFor: 'private' stamp: 'ToonVerwaest 3/21/2011 01:35'!
propagate
	target allSubclassesDo: [ :subclass |
		propagations add:
			(ClassModificationPropagation
				propagate: self
				to: subclass) ]
	
		! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 19:43'!
propagations
	^ propagations! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 14:30'!
removals: aCollection
	removals := aCollection! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 23:32'!
slotShift
	^ slotShift! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 15:25'!
subclassSlotOffset
	^ subclassSlotOffset! !

!ClassModification methodsFor: 'private' stamp: 'CamilloBruni 3/30/2011 15:40'!
superLayout
	^ superclass
		ifNil: [ NilLayout instance ]
		ifNotNil: [ superclass layout ]! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 19:34'!
superclass
	^ superclass! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 14:32'!
superclass: aClass
	superclass := aClass! !

AbstractClassModification subclass: #ClassModificationPropagation
	instanceVariableNames: 'origin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!ClassModificationPropagation classSide methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/20/2011 14:51'!
propagate: aModification to: aClass
	^ self new
		propagate: aModification
		to: aClass! !

!ClassModificationPropagation methodsFor: 'migrating' stamp: 'ToonVerwaest 3/27/2011 21:14'!
methodModification
	^ origin methodModification! !

!ClassModificationPropagation methodsFor: 'public' stamp: 'ToonVerwaest 3/20/2011 23:33'!
propagate: aModification to: aTarget
	origin := aModification.
	target := aTarget.
	ownSlotStart := target layout offset + aModification slotShift.
	self layout: (target layout reshapeTo: origin).! !

!ClassModificationPropagation methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:38'!
superclass
	^ target superclass! !

Object subclass: #AbstractFieldModification
	instanceVariableNames: 'fieldIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!AbstractFieldModification methodsFor: 'recompiling' stamp: 'ToonVerwaest 3/28/2011 17:52'!
applyToIR: aFieldAccess! !

!AbstractFieldModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:19'!
fieldIndex
	^ fieldIndex! !

!AbstractFieldModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:19'!
fieldIndex: anObject
	fieldIndex := anObject! !

!AbstractFieldModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:07'!
installOn: aModification
	self subclassResponsibility! !

!AbstractFieldModification methodsFor: 'migrating' stamp: 'ToonVerwaest 3/28/2011 20:31'!
migrateAt: index to: newInstance from: oldInstance! !

!AbstractFieldModification methodsFor: 'recompiling' stamp: 'ToonVerwaest 3/28/2011 18:29'!
rewriteIR: aNode usingModification: aMethodModification! !

AbstractFieldModification subclass: #AddedField
	instanceVariableNames: 'newSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!AddedField methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:07'!
installOn: aModification
	aModification installAddedSlot: self! !

!AddedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 19:48'!
name
	^ newSlot name! !

!AddedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:19'!
newFieldIndex
	^ newSlot index + fieldIndex! !

!AddedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:35'!
newSlot
	^ newSlot! !

!AddedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:35'!
newSlot: anObject
	newSlot := anObject! !

AbstractFieldModification subclass: #ModifiedField
	instanceVariableNames: 'newSlot originalSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!ModifiedField methodsFor: 'recompiling' stamp: 'ToonVerwaest 3/28/2011 17:53'!
applyToIR: aFieldAccess
	aFieldAccess number: self newFieldIndex! !

!ModifiedField methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:08'!
installOn: aModification
	aModification installModifiedSlot: self! !

!ModifiedField methodsFor: 'migrating' stamp: 'ToonVerwaest 3/30/2011 13:54'!
migrateAt: index to: newInstance from: oldInstance
	newInstance
		instVarAt: index
		put: (oldInstance instVarAt: self oldFieldIndex)! !

!ModifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:14'!
newFieldIndex
	^ newSlot index + fieldIndex! !

!ModifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:34'!
newSlot
	^ newSlot! !

!ModifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:34'!
newSlot: anObject
	newSlot := anObject! !

!ModifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:14'!
oldFieldIndex
	^ originalSlot index + fieldIndex! !

!ModifiedField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 18:50'!
originalSlot

	^ originalSlot! !

!ModifiedField methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/28/2011 18:50'!
originalSlot: anObject
	originalSlot := anObject! !

AbstractFieldModification subclass: #RemovedField
	instanceVariableNames: 'originalSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!RemovedField methodsFor: 'recompiling' stamp: 'ToonVerwaest 3/28/2011 18:07'!
applyToIR: aFieldAccess
	| nodes |
	nodes := aFieldAccess isRead
				ifTrue: [ self buildInvalidReadIRNodes ]
				ifFalse: [ self buildInvalidWriteIRNodes ].
	aFieldAccess sequence
		replaceNode: aFieldAccess
		withNodes: nodes! !

!RemovedField methodsFor: 'recompiling' stamp: 'ErwannNiko 3/30/2011 15:41'!
buildInvalidReadIRNodes
	^ {
		IRInstruction pushLiteral: self.
		IRInstruction send: #invalidRead.
	}! !

!RemovedField methodsFor: 'recompiling' stamp: 'ToonVerwaest 3/28/2011 19:54'!
buildInvalidWriteIRNodes
	^ {
		IRInstruction pushLiteral: self.
		IRInstruction send: #invalidWrite.
		IRInstruction popTop.
	}! !

!RemovedField methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:08'!
installOn: aModification
	aModification installRemovedSlot: self! !

!RemovedField methodsFor: 'runtime support' stamp: 'ToonVerwaest 3/28/2011 20:39'!
invalidRead
	self error: 'Trying to read from removed field: ', originalSlot name! !

!RemovedField methodsFor: 'runtime support' stamp: 'ToonVerwaest 3/28/2011 20:56'!
invalidWrite
	self error: 'Trying to write to removed field: ', originalSlot name! !

!RemovedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:19'!
oldFieldIndex
	^ originalSlot index + fieldIndex! !

!RemovedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:34'!
originalSlot
	^ originalSlot! !

!RemovedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:34'!
originalSlot: anObject
	originalSlot := anObject! !

!RemovedField methodsFor: 'recompiling' stamp: 'ErwannNiko 3/30/2011 16:36'!
rewriteIR: aNode usingModification: aMethodModification
	| addedField  newSlot |
	addedField := aMethodModification
		 addedSlotNamed: originalSlot name ifAbsent: [ ^ nil ].
	newSlot := addedField newSlot.
self	halt.
	aNode nextInstruction delete.
	aNode replaceWith: (IRInstruction pushInstVar: newSlot index ).
	! !

AbstractFieldModification subclass: #ShiftedField
	instanceVariableNames: 'shift'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!ShiftedField methodsFor: 'recompiling' stamp: 'ToonVerwaest 3/28/2011 20:27'!
applyToIR: aFieldAccess
	aFieldAccess number: aFieldAccess number + shift! !

!ShiftedField methodsFor: 'migrating' stamp: 'ToonVerwaest 3/28/2011 20:31'!
migrateAt: index to: newInstance from: oldInstance
	newInstance instVarAt: index put: (oldInstance instVarAt: index - shift)! !

!ShiftedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 20:27'!
shift
	^ shift! !

!ShiftedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 20:27'!
shift: anObject
	shift := anObject! !

AbstractFieldModification subclass: #UnmodifiedField
	instanceVariableNames: 'slot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!UnmodifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:27'!
fieldIndex
	^ slot index + fieldIndex! !

!UnmodifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:28'!
installOn: aModification
	aModification installUnmodifiedSlot: self! !

!UnmodifiedField methodsFor: 'migrating' stamp: 'ToonVerwaest 3/30/2011 13:55'!
migrateAt: index to: newInstance from: oldInstance
	newInstance
		instVarAt: index
		put: (oldInstance instVarAt: index)! !

!UnmodifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:48'!
slot
	^ slot! !

!UnmodifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:48'!
slot: anObject
	slot := anObject! !

Object subclass: #AbstractModification
	instanceVariableNames: 'slotShift modificationMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!AbstractModification classSide methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 3/24/2011 12:17'!
new: anInteger
	^ self new initialize: anInteger ! !

!AbstractModification methodsFor: 'initialize-release' stamp: 'ToonVerwaest 3/28/2011 19:46'!
initialize: anInteger
	self initialize.
	modificationMap := Array new: anInteger.! !

!AbstractModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:12'!
installAddedSlot: addedSlot
	self subclassResponsibility! !

!AbstractModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:12'!
installModifiedSlot: modifiedSlot
	self subclassResponsibility! !

!AbstractModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:12'!
installRemovedSlot: removedSlot
	self subclassResponsibility! !

!AbstractModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:29'!
installUnmodifiedSlot: unmodifiedSlot
	modificationMap
		at: unmodifiedSlot fieldIndex
		put: unmodifiedSlot! !

!AbstractModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/30/2011 13:52'!
modificationAt: idx
	idx > modificationMap size 
		ifTrue: [ ^ slotShift ].
	^ modificationMap at: idx! !

!AbstractModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/24/2011 12:18'!
size
	^ modificationMap size.! !

!AbstractModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/24/2011 11:37'!
slotShift: aShift
	slotShift := aShift! !

AbstractModification subclass: #InstanceModification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!InstanceModification methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 3/28/2011 17:13'!
installAddedSlot: addedSlot
	modificationMap at: addedSlot newFieldIndex put: addedSlot! !

!InstanceModification methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 3/28/2011 17:14'!
installModifiedSlot: modifiedSlot
	modificationMap at: modifiedSlot newFieldIndex put: modifiedSlot! !

!InstanceModification methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 3/28/2011 17:14'!
installRemovedSlot: removedSlot
	" ignore "! !

AbstractModification subclass: #MethodModification
	instanceVariableNames: 'addedSlots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!MethodModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 20:06'!
addedSlotNamed: name ifAbsent: aBlock
	^ addedSlots at: name ifAbsent: aBlock! !

!MethodModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 19:47'!
initialize
	addedSlots := Dictionary new! !

!MethodModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 19:48'!
installAddedSlot: addedSlot
	addedSlots at: addedSlot name put: addedSlot! !

!MethodModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:15'!
installModifiedSlot: modifiedSlot
	modificationMap at: modifiedSlot oldFieldIndex put: modifiedSlot! !

!MethodModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:15'!
installRemovedSlot: removedSlot
	modificationMap at: removedSlot oldFieldIndex put: removedSlot! !

Object subclass: #NilLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

NilLayout class
	instanceVariableNames: 'instance'!

NilLayout class
	instanceVariableNames: 'instance'!

!NilLayout classSide methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/20/2011 15:29'!
instance
	^ instance ifNil: [ instance := self new ]! !

!NilLayout methodsFor: 'extending' stamp: 'CamilloBruni 3/30/2011 19:21'!
extend: someSlots
	^ PointerLayout newFrom: someSlots! !

!NilLayout methodsFor: 'extending' stamp: 'ToonVerwaest 3/20/2011 15:27'!
extendByte
	^ ByteLayout new! !

!NilLayout methodsFor: 'extending' stamp: 'ToonVerwaest 3/20/2011 15:27'!
extendVariable: someSlots
	^ VariableLayout newFrom: someSlots! !

!NilLayout methodsFor: 'extending' stamp: 'ToonVerwaest 3/20/2011 15:27'!
extendWeak
	^ WeakLayout new! !

!NilLayout methodsFor: 'extending' stamp: 'ToonVerwaest 3/20/2011 15:28'!
extendWord
	^ WordLayout new! !

!NilLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 22:59'!
fixedSize
	^ 0! !

!NilLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:04'!
slotSize
	^ 0! !

Object subclass: #SlotClassBuilder
	instanceVariableNames: 'client oldClasses newClasses classSlots globals category superclass name oldClass metaChange classChange layoutClass slots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilder'!

!SlotClassBuilder commentStamp: 'ToonVerwaest 3/18/2011 16:43' prior: 0!
Update the following method:

updateInstances:from:isMeta:

to do:
	"Now perform a bulk mutation of old instances into new ones"
	oldInstances elementsForwardIdentityTo:  newInstances.
	
Delete the implementations of:
superclass:methodDictionary:format:
in all subclasses of Behavior (not in Behavior)


Usage:

SlotClassBuilder new
	class: #MyClass
	superclass: Object
	slots: {#x.#y.#z.}
	classSlots: {#a.#b.#c}
	globals: {}
	category: #MyCategory!

!SlotClassBuilder methodsFor: 'migrating' stamp: 'ToonVerwaest 3/28/2011 00:27'!
apply
	self apply: metaChange.
	self apply: classChange.

	client recategorize: oldClass to: category.! !

!SlotClassBuilder methodsFor: 'migrating' stamp: 'CamilloBruni 3/30/2011 13:14'!
apply: classModification
	self flag: 'Extract modifiesFormat from modifiesSlot. ModifiesFormat might make the whole hierarchy have modified formats, but no methods need to be recompiled...'.
	classModification modifiesSlots
		ifTrue: [self applySlotChange: classModification]
		ifFalse: [ 
			classModification modifesFormat
				ifTrue: [ self applyFormatChange: classModification]
				ifFalse: [
					classModification modifiesSuperclass
						ifTrue: [ self applySuperclassChange: classModification]
						ifFalse: [^ self ]]].
	
	client
		migrateClasses: oldClasses asArray
		to: newClasses asArray
		using: classModification instanceModification.
		
	oldClasses removeAll.
	newClasses removeAll.! !

!SlotClassBuilder methodsFor: 'migrating' stamp: 'CamilloBruni 3/30/2011 13:19'!
applyAndUpdateFormat: classModification
	| old new |
	old := classModification target.
	new := classModification apply.
	
	" Notify the system of the change "
	client classFormatChangedFrom: old to: new by: classModification.

	" Store the modification for updateClasses "
	oldClasses add: old.
	newClasses add: new.! !

!SlotClassBuilder methodsFor: 'migrating' stamp: 'CamilloBruni 3/29/2011 15:12'!
applyAndUpdateMethods: classModification
	| old new |
	old := classModification target.
	new := classModification apply.
	
	" Notify the system of the change "
	client classDefinitionChangedFrom: old to: new by: classModification.

	" Store the modification for updateClasses "
	oldClasses add: old.
	newClasses add: new.! !

!SlotClassBuilder methodsFor: 'migrating' stamp: 'CamilloBruni 3/30/2011 13:17'!
applyFormatChange: classModification
	self applyAndUpdateFormat: classModification.
	classModification propagations do: [ :propagation | 
		self applyAndUpdateFormat: propagation ]! !

!SlotClassBuilder methodsFor: 'migrating' stamp: 'CamilloBruni 3/29/2011 15:11'!
applyPropagations: classModification
	classModification propagations do: [ :propagation | 
		self applyAndUpdateMethods: propagation ]! !

!SlotClassBuilder methodsFor: 'migrating' stamp: 'CamilloBruni 3/30/2011 13:17'!
applySlotChange: classModification
	self applyAndUpdateMethods: classModification.
	classModification propagations do: [ :propagation | 
		self applyAndUpdateMethods: propagation ]! !

!SlotClassBuilder methodsFor: 'migrating' stamp: 'CamilloBruni 3/29/2011 15:36'!
applySuperclassChange: classModification
	client superclassChangedOf: classModification target 
								to: classModification superclass
								by: classModification.
	
	oldClasses add: classModification target.
	newClasses add: classModification target.! !

!SlotClassBuilder methodsFor: 'public' stamp: 'ToonVerwaest 3/28/2011 00:28'!
build
	self loadOldIfAbsent: [ ^ self buildNewClass ].

	self createMetaChange.
	
	classChange := ClassModification
						modify: oldClass
						extend: superclass
						withLayoutType: layoutClass
						slots: slots.
	
	self apply.
	
	^ oldClass! !

!SlotClassBuilder methodsFor: 'private' stamp: 'CamilloBruni 3/30/2011 19:21'!
buildNewClass
	| metaclass newClass |
	metaclass := Metaclass new.
	metaclass
		superclass: self metaOfSuper
		withLayoutType: PointerLayout
		slots: classSlots.

	newClass := metaclass new.
	newClass setName: name.
	
	newClass superclass: superclass
			withLayoutType: layoutClass slots: slots.
			
	client classAdded: newClass inCategory: category.
	
	^ newClass! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:28'!
category: aCategory
	category := aCategory! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:28'!
classSlots: someClassSlots
	classSlots := someClassSlots! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:28'!
client: aClient
	client := aClient! !

!SlotClassBuilder methodsFor: 'private' stamp: 'CamilloBruni 3/30/2011 19:21'!
createMetaChange
	self validateSuperChain.
	metaChange := ClassModification
						modify: oldClass class
						extend: self metaOfSuper
						withLayoutType: PointerLayout
						slots: classSlots! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:28'!
globals: globalsArray
	globals := globalsArray! !

!SlotClassBuilder methodsFor: 'initialize-release' stamp: 'CamilloBruni 3/30/2011 19:21'!
initialize
	oldClasses := OrderedCollection new.
	newClasses := OrderedCollection new.
	globals := {}.
	classSlots := {}.
	slots := {}.
	layoutClass := PointerLayout.
	superclass := Object.! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:29'!
layoutClass: aLayoutClass
	layoutClass := aLayoutClass! !

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 3/28/2011 00:29'!
loadOldIfAbsent: block
	oldClass := client classAt: name ifAbsent: block! !

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 3/28/2011 00:29'!
metaOfSuper
	 ^ superclass ifNil: [ Class ] ifNotNil: [ superclass class ].! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:29'!
name: aName
	name := aName.
	self validateClassName.! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:29'!
slots: someSlots
	slots := someSlots! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:29'!
superclass: aSuperclass
	superclass := aSuperclass.
	superclass ifNotNil: [ self validateClass: superclass ].
	client environment: superclass environment! !

!SlotClassBuilder methodsFor: 'validation' stamp: 'ToonVerwaest 3/28/2011 00:29'!
validateClass: aClass
	aClass isBehavior
		ifFalse: [ self error: 'Trying to build classes from non-class objects' ].
	aClass isMeta
		ifTrue: [ self error: 'Metaclasses cannot be used for building classes' ].! !

!SlotClassBuilder methodsFor: 'validation' stamp: 'ToonVerwaest 3/28/2011 00:29'!
validateClassName
	name isSymbol ifFalse: [
		self error: 'Class name should be a symbol.' ].
	name first canBeGlobalVarInitial ifFalse: [
		self error: 'Class name does not start with a valid Global Var Initial.' ].! !

!SlotClassBuilder methodsFor: 'validation' stamp: 'ToonVerwaest 3/28/2011 00:29'!
validateSuperChain
	superclass ifNil: [ ^ nil ].
	superclass withAllSuperclassesDo: [ :class |
		class == oldClass
			ifTrue: [ self error: 'Trying to build a circular hierarchy' ]].! !
